Index: /trunk/SophyaPI/PI/lut.cc
===================================================================
--- /trunk/SophyaPI/PI/lut.cc	(revision 3518)
+++ /trunk/SophyaPI/PI/lut.cc	(revision 3519)
@@ -15,10 +15,7 @@
 /* --Methode-- */
 
-LUT::LUT(double min, double max, unsigned short ncol, int typ, int ntable) 
+LUT::LUT(double min, double max, unsigned short ncol, int typ) 
 {
-int nlev;
-
-bornes=NULL;
-nlev = ncol-2;
+int nlev = ncol-2;
 if (nlev < 1)  nlev = 1;
 bornes = new double[nlev+1];
@@ -39,12 +36,25 @@
 delete[] table;
 }
+/* --Methode-- */
+void LUT::SetNCol(unsigned short ncol)
+{
+if (ncol == NCol())  return;
+double min = Min();
+double max = Max();
+if (bornes) delete[] bornes;
+int nlev = ncol-2;
+if (nlev < 1)  nlev = 1;
+bornes = new double[nlev+1];
+nLevel = nlev;
+SetLut(min, max, Type());
+}
 
 /* --Methode-- */
-void LUT::SetLut(double min, double max, int typ, int ntable)
+void LUT::SetLut(double min, double max, int typ)
 {
 
 if(  (typ != kLutType_Lin)  && (typ != kLutType_Log)
-  && (typ != kLutType_Sqrt) && (typ != kLutType_Square)
-  )  typ = kLutType_Lin;
+  && (typ != kLutType_Sqrt) && (typ != kLutType_Square)  
+  && (typ != kLutType_RGB) )  typ = kLutType_Lin;
 type = typ;
 if (max <= min)  max = min+1.;
@@ -57,4 +67,5 @@
     {
     case kLutType_Lin :
+    case kLutType_RGB :
       dx = (max-min)/(double)nLevel;
       for(i=0; i<nLevel; i++)
@@ -84,5 +95,6 @@
   }
 else  bornes[0] = 0.5*(min+max);
-ComputeTable((ntable > nLevel) ? ntable : tablenbin);
+// ComputeTable((ntable > nLevel) ? ntable : tablenbin);
+ComputeTable(0);
 return; 
 }
@@ -110,4 +122,26 @@
 
 /* --Methode-- */
+unsigned short LUT::ApplyRGB(double x)
+{
+  long lv = x+0.3;
+  double r = (lv%256);
+  lv /= 256;
+  double g = (lv%256);
+  lv /= 256;
+  double b = (lv%256);
+  int qqq = 1;
+  int quantum = 1;
+  for(quantum=2; quantum<=42; quantum++) {
+  	qqq = quantum*quantum*quantum;
+  	if (qqq > NCol())  break;
+  }
+  quantum--;
+  int ir = AppFast(r)*quantum/(NCol());
+  int ig = AppFast(g)*quantum/(NCol());
+  int ib = AppFast(b)*quantum/(NCol());
+  return ((unsigned short)((ib*quantum+ig)*quantum+ir));
+}
+
+/* --Methode-- */
 void LUT::ComputeTable(int nt)
 {
@@ -115,4 +149,5 @@
 else if (nt < (nLevel+2))  nt = (nLevel+2);
 tablenbin = nt;
+if (table) delete[] table;
 table = new unsigned short [nt-2];
 tablebinwidth = (Max()-Min())/(nt-2);
Index: /trunk/SophyaPI/PI/lut.h
===================================================================
--- /trunk/SophyaPI/PI/lut.h	(revision 3518)
+++ /trunk/SophyaPI/PI/lut.h	(revision 3519)
@@ -13,5 +13,5 @@
 
 // Type de lut possibles 
-enum {kLutType_Lin=1, kLutType_Log=2, kLutType_Sqrt=3, kLutType_Square=4};
+enum {kLutType_Lin=1, kLutType_Log=2, kLutType_Sqrt=3, kLutType_Square=4, kLutType_RGB=11 };
 
 class LUT 
@@ -19,16 +19,18 @@
 public:
   
-  LUT(double min, double max, unsigned short ncol=16, int typ=kLutType_Lin, int ntable=0);
+  LUT(double min, double max, unsigned short ncol=16, int typ=kLutType_Lin);
   ~LUT();
-  void SetLut(double min, double max, int typ=kLutType_Lin, int ntable=0);
+  void SetNCol(unsigned short ncol);
+  void SetLut(double min, double max, int typ=kLutType_Lin);
   void Print();
   unsigned short Apply(double x);
+  unsigned short ApplyRGB(double x);
+
   inline unsigned short ApplyFast(double x)
     { 
-    if (x < Min())  return(0);
-    if (x >= Max() )  return(nLevel+1);  
-    int k = (int)((x-Min())/tablebinwidth);
-    return(table[k]); 
+    if (type == kLutType_RGB) return ApplyRGB(x); 
+    else return AppFast(x);	
     } 
+
 
   inline double Min() { return(bornes[0]); };
@@ -37,7 +39,15 @@
   inline int NCol() { return(nLevel+2); };
 
+
 protected:
   void ComputeTable(int nt);
-
+  inline unsigned short AppFast(double x)
+    {
+    if (x < Min())  return(0);
+    if (x >= Max() )  return(nLevel+1);  
+    int k = (int)((x-Min())/tablebinwidth);
+    return(table[k]); 
+    } 
+  	  
   int type;
   int nLevel;
Index: /trunk/SophyaPI/PI/objlist.list
===================================================================
--- /trunk/SophyaPI/PI/objlist.list	(revision 3518)
+++ /trunk/SophyaPI/PI/objlist.list	(revision 3519)
@@ -1,2 +1,3 @@
+copy_pipixmapx.o
 lut.o
 parradapter.o
@@ -48,4 +49,5 @@
 pipixmapgen.o
 pipixmapx.o
+pipixutils.o
 piscdrawwdg.o
 pistdwdggen.o
Index: /trunk/SophyaPI/PI/parradapter.cc
===================================================================
--- /trunk/SophyaPI/PI/parradapter.cc	(revision 3518)
+++ /trunk/SophyaPI/PI/parradapter.cc	(revision 3519)
@@ -174,4 +174,19 @@
 
 /* --Methode-- */
+double  P2DArrayAdapter::MeanVal(int ix1, int ix2, int jy1, int jy2)
+{
+int ec;
+if (ix1>ix2) { ec=ix1; ix1=ix2; ix2=ec; }
+if (jy1>jy2) { ec=jy1; jy1=jy2; jy2=ec; }    
+// On calcule la somme des pixels dans la zone
+double ss = 0.;
+for(int j=jy1; j<=jy2; j++) 
+  for(int i=ix1; i<=ix2; i++)  ss += Value(i,j);
+
+ss /= (double)((jy2-jy1+1)*(ix2-ix1+1));
+return ss;  
+}   
+
+/* --Methode-- */
 void P2DArrayAdapter::XYfromxy(int ix, int iy, double& x, double& y)
 {
@@ -433,13 +448,11 @@
 
 /* --Methode-- */
-unsigned char * P2DArrayAdapter::ComputePixmap(LUT* lut, int ofx, int ofy, int zm, 
-                int xwsz, int ywsz, unsigned char * opix, int * oxsp, int * oysp)
+void P2DArrayAdapter::ComputePixmap(LUT* lut, int ofx, int ofy, int zm, 
+                                    int xwsz, int ywsz, PIPixColIdx & pixc)
 {
 // TIMEF ; 
-unsigned char *pix, *pp, ucp;
 int zmm=1;
-int npx, npy, nppx, nppy, nszp, oszp;
+int npx, npy, nppx, nppy;
 int i,j,k,l;
-double vpx;
 
 /*
@@ -448,6 +461,7 @@
 */
 
-if ( (XSize() <= 0) || (YSize() <= 0) || (lut == NULL) || (ofx < 0) || (ofy < 0) ) 
-  { *oxsp = *oysp = 0; return(NULL); }
+if ( (XSize() <= 0) || (YSize() <= 0) || (lut == NULL) || (ofx < 0) || (ofy < 0) ) {
+  pixc.DeAlloc();  return; 
+}
 
 npx = XSize()-ofx;
@@ -471,21 +485,18 @@
   }
 
-oszp = (*oxsp)*(*oysp);
-nszp = nppx*nppy;
-if ( oszp != nszp )
-  {
-  if (opix)  delete[] opix;
-  pix = new unsigned char[nppx*nppy];
-  if (pix == NULL)  { *oxsp = *oysp = 0; ; return(NULL); }
-  }
-else  pix = opix;
-*oxsp = nppx; *oysp = nppy;
-
+
+/* printf("Debug_ComputePixmap %d %d %d (%d-%d %d-%d)\n", 
+      ofx, ofy, zm, npx,nppx, npy,nppy); */
+if (lut->NCol() <= 256) {  // On fait un pixmap de type Byte/pixel 
 /*
-printf("Debug_ComputePixmap %d %d %d (%d-%d %d-%d)\n", 
-      ofx, ofy, zm, npx,nppx, npy,nppy);
-*/
-
-pp = pix;
+printf("Debug_ComputePixmap- pixc.AllocateByte() type=%d - %d %d %d - %d %d %d - %d %d %d \n",
+  lut->Type(), 
+  lut->ApplyFast(0.), lut->ApplyFast(1.), lut->ApplyFast(2.), 
+  lut->ApplyRGB(0.), lut->ApplyRGB(1.), lut->ApplyRGB(2.), 
+  lut->Apply(0.), lut->Apply(1.), lut->Apply(2.));
+*/  
+unsigned char *pp, ucp;
+pixc.AllocateByte(nppx, nppy);
+pp = pixc.BytePointer();
 if (eXY) { // Echange Axe X,Y 
   if (zm == 1)  {  // Pas de zoom  
@@ -497,14 +508,10 @@
     }
   else if (zm < -1) {       // Compression 
-    double fv = (double)(zmm*zmm); 
     for(j=ofy; j<ofy+npy; j+=zmm)
-      for(i=ofx; i<ofx+npx; i+=zmm) {
-        vpx = 0;
-        for(l=0; l<zmm; l++)
-          for(k=0; k<zmm; k++)
-            vpx += this->Value( (j+l)*sgnX+offX, (i+k)*sgnY+offY);
-        *pp = (unsigned char) lut->ApplyFast(vpx/fv); 
+      for(i=ofx; i<ofx+npx; i+=zmm) { 
+        *pp = lut->ApplyFast( MeanVal(j*sgnX+offX, (j+zmm-1)*sgnX+offX, 
+                                      i*sgnY+offY, (i+zmm-1)*sgnY+offY) );
         pp++;
-        }
+      }
     }
   else  {      // Agrandissement
@@ -513,5 +520,5 @@
         ucp = (unsigned char) lut->ApplyFast(this->Value(j*sgnX+offX, i*sgnY+offY));
         for(l=0; l<zm; l++)  {
-          pp = pix+((j-ofy)*zm+l)*nppx+((i-ofx)*zm);
+          pp = pixc.BytePointer()+((j-ofy)*zm+l)*nppx+((i-ofx)*zm);
           for(k=0; k<zm; k++)  { *pp = ucp; pp++; }  
 	  }
@@ -528,14 +535,10 @@
     }
   else if (zm < -1) {       // Compression 
-    double fv = (double)(zmm*zmm); 
     for(j=ofy; j<ofy+npy; j+=zmm)
       for(i=ofx; i<ofx+npx; i+=zmm) {
-        vpx = 0;
-        for(l=0; l<zmm; l++)
-          for(k=0; k<zmm; k++)
-            vpx += this->Value( (i+k)*sgnX+offX, (j+l)*sgnY+offY);
-        *pp = (unsigned char) lut->ApplyFast(vpx/fv); 
+        *pp = lut->ApplyFast( MeanVal(i*sgnX+offX, (i+zmm-1)*sgnX+offX, 
+                                      j*sgnY+offY, (j+zmm-1)*sgnY+offY) );
         pp++;
-        }
+      }
     }
   else  {      // Agrandissement
@@ -544,5 +547,5 @@
         ucp = (unsigned char) lut->ApplyFast(this->Value(i*sgnX+offX, j*sgnY+offY));
         for(l=0; l<zm; l++)  {
-          pp = pix+((j-ofy)*zm+l)*nppx+((i-ofx)*zm);
+          pp = pixc.BytePointer()+((j-ofy)*zm+l)*nppx+((i-ofx)*zm);
           for(k=0; k<zm; k++)  { *pp = ucp; pp++; }  
 	  }
@@ -550,5 +553,67 @@
     }
   }
-return(pix);
+}  //  ---- Fin pixmap de type Byte
+else {  // On fait un pixmap de type short/pixel 
+// printf("Debug_ComputePixmap- pixc.AllocateShort() \n");
+unsigned short *pp, ucp;
+pixc.AllocateShort(nppx, nppy);
+pp = pixc.ShortPointer();
+if (eXY) { // Echange Axe X,Y 
+  if (zm == 1)  {  // Pas de zoom  
+    for(j=ofy; j<ofy+npy; j++)
+      for(i=ofx; i<ofx+npx; i++) 
+        { *pp = (unsigned char) lut->ApplyFast( 
+                this->Value(j*sgnX+offX, i*sgnY+offY));  
+           pp++; }
+    }
+  else if (zm < -1) {       // Compression 
+    for(j=ofy; j<ofy+npy; j+=zmm)
+      for(i=ofx; i<ofx+npx; i+=zmm) { 
+        *pp = lut->ApplyFast( MeanVal(j*sgnX+offX, (j+zmm-1)*sgnX+offX, 
+                                      i*sgnY+offY, (i+zmm-1)*sgnY+offY) );
+        pp++;
+      }
+    }
+  else  {      // Agrandissement
+    for(j=ofy; j<ofy+npy; j++)
+      for(i=ofx; i<ofx+npx; i++)  {
+        ucp = (unsigned char) lut->ApplyFast(this->Value(j*sgnX+offX, i*sgnY+offY));
+        for(l=0; l<zm; l++)  {
+          pp = pixc.ShortPointer()+((j-ofy)*zm+l)*nppx+((i-ofx)*zm);
+          for(k=0; k<zm; k++)  { *pp = ucp; pp++; }  
+	  }
+        }
+    }
+  }     // Fin du cas avec echange d'axe X/Y 
+else {
+  if (zm == 1)  {  // Pas de zoom  
+    for(j=ofy; j<ofy+npy; j++)
+      for(i=ofx; i<ofx+npx; i++) 
+        { *pp = (unsigned char) lut->ApplyFast( 
+                this->Value(i*sgnX+offX, j*sgnY+offY));  
+           pp++; }
+    }
+  else if (zm < -1) {       // Compression 
+    for(j=ofy; j<ofy+npy; j+=zmm)
+      for(i=ofx; i<ofx+npx; i+=zmm) {
+        *pp = lut->ApplyFast( MeanVal(i*sgnX+offX, (i+zmm-1)*sgnX+offX, 
+                                      j*sgnY+offY, (j+zmm-1)*sgnY+offY) );
+        pp++;
+      }
+    }
+  else  {      // Agrandissement
+    for(j=ofy; j<ofy+npy; j++)
+      for(i=ofx; i<ofx+npx; i++)  {
+        ucp = (unsigned char) lut->ApplyFast(this->Value(i*sgnX+offX, j*sgnY+offY));
+        for(l=0; l<zm; l++)  {
+          pp = pixc.ShortPointer()+((j-ofy)*zm+l)*nppx+((i-ofx)*zm);
+          for(k=0; k<zm; k++)  { *pp = ucp; pp++; }  
+	  }
+        }
+    }
+  }
+}  //  ---- Fin pixmap de type Byte
+
+return;
 }
 
Index: /trunk/SophyaPI/PI/parradapter.h
===================================================================
--- /trunk/SophyaPI/PI/parradapter.h	(revision 3518)
+++ /trunk/SophyaPI/PI/parradapter.h	(revision 3519)
@@ -9,4 +9,5 @@
 #include "machdefs.h"
 #include "lut.h"
+#include "pipixutils.h"
 
 #include <string> 
@@ -54,5 +55,7 @@
   virtual void    DefineXYCoordinates(double x0, double y0, double dx, double dy);
 // Doit etre defini par les classes derivees
-  virtual double  Value(int ix, int iy) = 0;   
+  virtual double  Value(int ix, int iy) = 0;
+// Peut etre redefini pour les classes derivees, pour une optimisation par exemple     
+  virtual double  MeanVal(int ix1, int ix2, int jy1, int jy2);   
 
   virtual void    XYfromxy(int ix, int iy, double& x, double& y);
@@ -89,7 +92,6 @@
 
 //    Calcul pixmap avec un LUT
-  virtual unsigned char * ComputePixmap(LUT* lut, int ofx, int ofy, int zm, 
-                           int xwsz, int ywsz, unsigned char * opix, 
-                           int * oxsp, int * oysp);
+  virtual void ComputePixmap(LUT* lut, int ofx, int ofy, int zm, 
+                             int xwsz, int ywsz, PIPixColIdx & pixc);
 
 //   Methode de decodage des options - Implementation par defaut ne fait rien
@@ -109,4 +111,6 @@
 };
 
+//  Adaptateur de tableau 1D pour pointeur de type T *
+
 template <class T> 
 class P1DAdapter : public P1DArrayAdapter {
@@ -126,4 +130,5 @@
 
 
+//  Adaptateur de tableau 2D pour pointeur de type T *
 template <class T> 
 class P2DAdapter : public P2DArrayAdapter {
@@ -134,7 +139,19 @@
 
   virtual 	  ~P2DAdapter() { if ( (aDel) && (mData) ) delete[] mData; }
-  virtual double   Value(int ix, int iy) 
+  virtual double  Value(int ix, int iy) 
                     {  if ( (ix < 0)  || (iy < 0) || (ix >= sX) || (iy >= sY) ) return(0.); 
                     return(mData[ix+iy*sX]); }
+  virtual double  MeanVal(int ix1, int ix2, int jy1, int jy2)  
+    {
+    int ec;
+    if (ix1>ix2) { ec=ix1; ix1=ix2; ix2=ec; }
+    if (jy1>jy2) { ec=jy1; jy1=jy2; jy2=ec; }    
+    double ss = 0.;
+    for(int j=jy1; j<=jy2; j++) 
+      for(int i=ix1; i<=ix2; i++)  ss += (double)(mData[i+j*sX]);
+    ss /= (double)((jy2-jy1+1)*(ix2-ix1+1));
+    return ss;  
+    }   
+
 protected :
   bool aDel;
@@ -142,4 +159,42 @@
 };
 
+//  Adaptateur de tableau 2D pour tableau RGB 
+
+class P2DPixRGBAdapter : public P2DArrayAdapter {
+public :
+          P2DPixRGBAdapter(PIPixRGBArray * rgbp, bool ad=false) :
+             P2DArrayAdapter(rgbp->XSize(), rgbp->YSize() )
+                { aDel = ad; mPix = rgbp; }
+  virtual ~P2DPixRGBAdapter() { if ( (aDel) && (mPix) ) delete mPix; }
+
+  virtual double  Value(int ix, int iy) 
+    {  
+    if ( (ix < 0)  || (iy < 0) || (ix >= sX) || (iy >= sY) ) return(0.); 
+    PIPixRGB rgb = (*mPix)(ix, iy);
+    return ( ((double)rgb.blue*256.+(double)rgb.green)*256.+(double)rgb.red );
+    }
+  virtual double  MeanVal(int ix1, int ix2, int jy1, int jy2)  
+    {
+    int ec;
+    if (ix1>ix2) { ec=ix1; ix1=ix2; ix2=ec; }
+    if (jy1>jy2) { ec=jy1; jy1=jy2; jy2=ec; }    
+    int r = 0;
+    int g = 0;
+    int b = 0;
+    for(int j=jy1; j<=jy2; j++) 
+      for(int i=ix1; i<=ix2; i++)  {
+      	PIPixRGB rgb = (*mPix)(i, j);
+      	r += rgb.red;  g += rgb.green;   b += rgb.blue; 
+      }
+    int n = (jy2-jy1+1)*(ix2-ix1+1);   
+    r /= n; g /= n; b /= n;
+    return ( ((double)b*256.+(double)g)*256.+(double)r );  
+    }   
+                    
+protected :
+  bool aDel;
+  PIPixRGBArray* mPix;
+};
+
 
 
Index: /trunk/SophyaPI/PI/picmap.cc
===================================================================
--- /trunk/SophyaPI/PI/picmap.cc	(revision 3518)
+++ /trunk/SophyaPI/PI/picmap.cc	(revision 3519)
@@ -24,9 +24,10 @@
 //--
 
-#define  MXMAPIDS   30
+#define  MXMAPIDS   33
 static   int    MapNCols[MXMAPIDS] = {
   256, 256, 256, 256, 256, 256, 256, 256, 256, 256,
   256, 256, 256, 256, 256, 256, 256, 256, 256, 256, 
-  256, 256, 256, 256, 256, 256, 256, 256, 256, 256  };
+  256, 256, 256, 256, 256, 256, 256, 256, 256, 256,
+  216, 512, 4096  };
 
 // Tables de couleurs :
@@ -37,4 +38,7 @@
 // 1 Standard PI 64 couleurs differentes
 // 1 Standard PI 16 couleurs
+// 1 Standard PI , 216 couleurs RGB (6x6x6)
+// 1 Standard PI , 512 couleurs RGB (8x8x8)
+// 1 Standard PI , 4096 couleurs RGB (16x16x16)
 
 static   const char*  MapNoms[MXMAPIDS]  = {
@@ -47,5 +51,5 @@
                       "MIDAS_Stairs9","MIDAS_StairCase","MIDAS_Color",
                       "MIDAS_ManyCol","MIDAS_Idl14","MIDAS_Idl15",
-                      "MultiCol16","MultiCol64"};
+ 		      "MultiCol16","MultiCol64","RGB216CM","RGB512CM","RGB4096CM"};
 
 static   CMapId MapIds[MXMAPIDS] = { 
@@ -58,5 +62,5 @@
                       CMAP_MIDAS_Stairs9, CMAP_MIDAS_StairCase, CMAP_MIDAS_Color, 
                       CMAP_MIDAS_ManyCol, CMAP_MIDAS_Idl14, CMAP_MIDAS_Idl15, 
-                      CMAP_COL16, CMAP_COL64 } ;
+                      CMAP_COL16, CMAP_COL64, CMAP_RGB216, CMAP_RGB512, CMAP_RGB4096, } ;
 
 static   int mColTNums[8192];   // Max 8192 tables differentes pour le moment  
@@ -70,5 +74,6 @@
                                   NULL, NULL, NULL, NULL, NULL,
                                   NULL, NULL, NULL, NULL, NULL, 
-                                  NULL, NULL, NULL, NULL, NULL };
+                                  NULL, NULL, NULL, NULL, NULL,
+                                  NULL, NULL, NULL,  };
 
 int  PIColorMap::NumberStandardColorMaps()
@@ -122,6 +127,10 @@
 //|	CMAP_COL64      :  64 Couleurs arcenciel 
 //|	CMAP_OTHER      :  Table non standard 
+//|	CMAP_RGB216     :  216 couleurs, 6x6x6 couleurs en composantes RGB
+//|	CMAP_RGB512     :  512 couleurs, 8x8x8 couleurs en composantes RGB
+//|	CMAP_RGB4096    :  4096 couleurs, 16x16x16 couleurs en composantes RGB
+
 //	Toutes les tables de couleurs standard possèdent 256 cellules de couleurs,
-//	contenant 16 ou 32 ou 128 couleurs distinctes.
+//	contenant 16 ou 32 ou 128 (ou 216) couleurs distinctes, sauf CMAP_RGB512 et CMAP_RGB4096.
 //
 // PIColorMap(string const& nom, int nCol)
@@ -563,4 +572,42 @@
       }
       break;
+
+    case CMAP_RGB216 :
+      i = 0;
+      for(int kb=0; kb<6; kb++) {
+        mycol.blue = (unsigned short)(kb*65535/5);
+        for(int jg=0; jg<6; jg++) { 
+          mycol.green = (unsigned short)(jg*65535/5);
+          for(int ir=0; ir<6; ir++) {
+            mycol.red = (unsigned short)(ir*65535/5);
+            AllocColor(mycol, i);   i++;
+          }
+        }            
+      }
+      mycol.blue = mycol.green =  mycol.red = 65535;
+      for(i=216; i<256; i++)
+        AllocColor(mycol, i);
+      break;
+
+    case CMAP_RGB512 :
+    case CMAP_RGB4096 :
+      {
+      int nlev = 8;
+      if ( mType == CMAP_RGB4096)  nlev = 16;
+      int drgb = 65535/(nlev-1);
+      i = 0;
+      for(int kb=0; kb<8; kb++) {
+        mycol.blue = (unsigned short)(kb*drgb);
+        for(int jg=0; jg<8; jg++) { 
+          mycol.green = (unsigned short)(jg*drgb);
+          for(int ir=0; ir<8; ir++) {
+            mycol.red = (unsigned short)(ir*drgb);
+            AllocColor(mycol, i);   i++;
+          }
+        }            
+      }
+      }
+      break;
+
 //----------------------------------------------------------
 //----------------------------------------------------------
Index: /trunk/SophyaPI/PI/picmap.h
===================================================================
--- /trunk/SophyaPI/PI/picmap.h	(revision 3518)
+++ /trunk/SophyaPI/PI/picmap.h	(revision 3519)
@@ -47,6 +47,10 @@
 
  //  Table simple a 16/64 couleurs 
- CMAP_COL16       = 998,        // 16 Couleurs arcenciel
- CMAP_COL64       = 999         // 64 Couleurs differentes
+ CMAP_COL16       = 991,        // 16 Couleurs arcenciel
+ CMAP_COL64       = 992,         // 64 Couleurs differentes
+ // Table de couleurs RGB 6x6x6=216 couleurs
+ CMAP_RGB216      = 993,        // 216 couleurs avec toutes les nuances RGB
+ CMAP_RGB512      = 994,        // 512 couleurs avec toutes les nuances RGB
+ CMAP_RGB4096     = 995         // 4096 couleurs avec toutes les nuances RGB
  };
 
Index: /trunk/SophyaPI/PI/pigraphgen.h
===================================================================
--- /trunk/SophyaPI/PI/pigraphgen.h	(revision 3518)
+++ /trunk/SophyaPI/PI/pigraphgen.h	(revision 3519)
@@ -17,4 +17,5 @@
 
 #include "pilineatt.h"  // Class PILineAtt
+#include "pipixutils.h"  // classes utilitaires pour pixels/RGB ...
 
 
@@ -118,6 +119,6 @@
 				     bool fgline=true);
 
-  virtual void       DrawPixmap(PIGrCoord x, PIGrCoord y, unsigned char *pix, 
-                                int sx, int sy, PIColorMap* cmap)              = 0;
+  virtual void       DrawPixmap(PIGrCoord x, PIGrCoord y, PIPixColIdx & pix, 
+                                PIColorMap* cmap)                              = 0;
 
 // Modifications attributs graphiques
Index: /trunk/SophyaPI/PI/pigraphps.cc
===================================================================
--- /trunk/SophyaPI/PI/pigraphps.cc	(revision 3518)
+++ /trunk/SophyaPI/PI/pigraphps.cc	(revision 3519)
@@ -324,11 +324,16 @@
 
 /* --Methode-- */
-void PIGraphicPS::DrawPixmap(PIGrCoord x, PIGrCoord y, unsigned char *pix, 
-                            int sx, int sy, PIColorMap* cmap)
-{
+void PIGraphicPS::DrawPixmap(PIGrCoord x, PIGrCoord y, PIPixColIdx & pixc, PIColorMap* cmap) 
+{
+int sx = pixc.XSize();
+int sy = pixc.YSize();
 if ( (sx < 1) || (sy < 1) )  return;
-if ((pix == NULL) || (cmap == NULL)) return;
-if(mPSOut) 
-  mPSOut->Image((double)x, (double)y, (double)sx, (double)sy, sx, sy, pix, cmap);
+if (cmap == NULL) return;
+if(mPSOut) {
+  if (pixc.BytePointer()) 
+    mPSOut->Image((double)x, (double)y, (double)sx, (double)sy, sx, sy, pixc.BytePointer(), cmap);
+  else if (pixc.ShortPointer()) 
+    mPSOut->Image((double)x, (double)y, (double)sx, (double)sy, sx, sy, pixc.ShortPointer(), cmap);
+}
 return;
 }
Index: /trunk/SophyaPI/PI/pigraphps.h
===================================================================
--- /trunk/SophyaPI/PI/pigraphps.h	(revision 3518)
+++ /trunk/SophyaPI/PI/pigraphps.h	(revision 3519)
@@ -38,6 +38,5 @@
   virtual void       DrawMarker(PIGrCoord x0, PIGrCoord y0);
   virtual void       DrawMarkers(PIGrCoord *x, PIGrCoord *y, int n);
-  virtual void       DrawPixmap(PIGrCoord x, PIGrCoord y, unsigned char *pix, 
-                                int sx, int sy, PIColorMap* cmap);
+  virtual void       DrawPixmap(PIGrCoord x, PIGrCoord y, PIPixColIdx & pix,  PIColorMap* cmap);
 
 // Modifications attributs graphiques
Index: /trunk/SophyaPI/PI/pigraphuc.cc
===================================================================
--- /trunk/SophyaPI/PI/pigraphuc.cc	(revision 3518)
+++ /trunk/SophyaPI/PI/pigraphuc.cc	(revision 3519)
@@ -729,13 +729,12 @@
 
 /* --Methode-- */
-void PIGraphicUC::DrawPixmap(PIGrCoord x, PIGrCoord y, unsigned char *pix,
-                        int sx, int sy, PIColorMap* cmap)
-{
-  if (!mGrC) return;
-  if ( (sx < 1) || (sy < 1) )  return;
-  if ((pix == NULL) || (cmap == NULL)) return; 
+void PIGraphicUC::DrawPixmap(PIGrCoord x, PIGrCoord y, PIPixColIdx & pix, PIColorMap* cmap)
+{
+  if (!mGrC) return;
+  if ( (pix.XSize() < 1) || (pix.YSize() < 1) )  return;
+  if (cmap == NULL) return; 
   double xf,yf;
   UC2GrC(x, y, xf, yf);
-  mGrC->DrawPixmap(xf, yf, pix, sx, sy, cmap);
+  mGrC->DrawPixmap(xf, yf, pix, cmap);
 }
 
Index: /trunk/SophyaPI/PI/pigraphuc.h
===================================================================
--- /trunk/SophyaPI/PI/pigraphuc.h	(revision 3518)
+++ /trunk/SophyaPI/PI/pigraphuc.h	(revision 3519)
@@ -78,6 +78,5 @@
 				     bool fgline=true);
 
-  virtual void       DrawPixmap(PIGrCoord x, PIGrCoord y, unsigned char *pix, 
-                                int sx, int sy, PIColorMap* cmap);
+  virtual void       DrawPixmap(PIGrCoord x, PIGrCoord y, PIPixColIdx & pix, PIColorMap* cmap);
 
 // Modifications attributs graphiques
Index: /trunk/SophyaPI/PI/pigraphx.cc
===================================================================
--- /trunk/SophyaPI/PI/pigraphx.cc	(revision 3518)
+++ /trunk/SophyaPI/PI/pigraphx.cc	(revision 3519)
@@ -384,6 +384,5 @@
 
 /* --Methode-- */
-void PIGraphicX::DrawPixmap(PIGrCoord x, PIGrCoord y, unsigned char *pix, 
-                            int sx, int sy, PIColorMap* cmap)
+void PIGraphicX::DrawPixmap(PIGrCoord x, PIGrCoord y, PIPixColIdx & pixc, PIColorMap* cmap) 
 {
 Window xw;
@@ -395,6 +394,7 @@
 XImage * ximg;
 
-if ( (sx < 1) || (sy < 1) )  return;
-if ((pix == NULL) || (cmap == NULL)) return; 
+int sx = pixc.XSize();
+int sy = pixc.YSize();
+if ((sx==0) || (sx==0) || (cmap == NULL)) return; 
 
   
@@ -406,5 +406,5 @@
 pad = (depth > 8) ? 32 : 8;
 ximg = XCreateImage (mdsp,DefaultVisual(mdsp,scr),
-                     depth,ZPixmap,0,NULL, sx, sy, pad,0);
+                     depth,ZPixmap,0,NULL, sx,sy, pad,0);
 if (ximg == NULL)  return;
 ximg->data = new char [sy*ximg->bytes_per_line];
@@ -412,7 +412,20 @@
   { XFree(ximg); return; }
 
-for(j=0; j<sy; j++)
-  for(i=0; i<sx; i++)
-    { XPutPixel(ximg, i, j, cmap->Color(*pix) );  pix++; }
+if (pixc.BytePointer()) {
+  unsigned char * pix = pixc.BytePointer();
+  for(j=0; j<sy; j++)
+    for(i=0; i<sx; i++)
+      { XPutPixel(ximg, i, j, cmap->Color(*pix) );  pix++; }
+}
+else if (pixc.ShortPointer()) {
+  unsigned short * pix = pixc.ShortPointer();
+  for(j=0; j<sy; j++)
+    for(i=0; i<sx; i++)
+      { XPutPixel(ximg, i, j, cmap->Color(*pix) );  pix++; }
+}
+else {
+  for(j=0; j<sy; j++)
+    for(i=0; i<sx; i++)  XPutPixel(ximg, i, j, 0 );  
+}
 
 XPutImage(mdsp, xw, DefGC(), ximg, 0, 0, (int)x, (int)y, sx, sy);
Index: /trunk/SophyaPI/PI/pigraphx.h
===================================================================
--- /trunk/SophyaPI/PI/pigraphx.h	(revision 3518)
+++ /trunk/SophyaPI/PI/pigraphx.h	(revision 3519)
@@ -38,6 +38,5 @@
   virtual void       DrawMarker(PIGrCoord x0, PIGrCoord y0);
   virtual void       DrawMarkers(PIGrCoord *x, PIGrCoord *y, int n);
-  virtual void       DrawPixmap(PIGrCoord x, PIGrCoord y, unsigned char *pix, 
-                                int sx, int sy, PIColorMap* cmap);
+  virtual void       DrawPixmap(PIGrCoord x, PIGrCoord y,  PIPixColIdx & pix,  PIColorMap* cmap);
 
 // Modifications attributs graphiques
Index: /trunk/SophyaPI/PI/piimage.cc
===================================================================
--- /trunk/SophyaPI/PI/piimage.cc	(revision 3518)
+++ /trunk/SophyaPI/PI/piimage.cc	(revision 3519)
@@ -128,7 +128,4 @@
 cutscw = NULL; 
 
-gpixm = zpixm = pixm = NULL;
-xsgpxm = xszpxm = xspxm = 0;
-ysgpxm = yszpxm = yspxm = 0;
 lut = NULL; 
 offx = offy = 0;
@@ -174,15 +171,12 @@
 PIImage::~PIImage()
 {
-if (pixm) delete pixm;
-if (zpixm) delete zpixm;
 if (zow) 
   {
-  zow->SetPixmap(NULL,0,0);
+  zow->SetPixmap(NULL);
   zow->EraseWindow();
   }
-if (gpixm) delete gpixm;
 if (gvw) 
   {
-  gvw->SetPixmap(NULL,0,0);
+  gvw->SetPixmap(NULL);
   gvw->EraseWindow();
   gvw->SetMsg(0); gvw->SetMsgParent(NULL); 
@@ -256,7 +250,5 @@
 xszpav = yszpav = 1;
 img = pim;
-if (gpixm) delete gpixm;
-gpixm = NULL;
-xsgpxm = ysgpxm = 0;
+gpixm.DeAlloc();
 zmgv = 1;
 
@@ -641,4 +633,5 @@
       else if (opts.substr(4,4) == "sqrt")  typlut=kLutType_Sqrt;
       else if (opts.substr(4,6) == "square")  typlut=kLutType_Square;
+      else if (opts.substr(4,6) == "rgb")  typlut=kLutType_RGB;
       SetLut(AutoLut_No, min, max, typlut, 0, false);
       continue;
@@ -672,5 +665,7 @@
   }
   // Set color map if requested
-  if(fgcmapid || revcmapid) SetColMapId(cmapid,revcmapid,false);
+  if(fgcmapid || revcmapid) 
+    SetColMapId(cmapid,revcmapid,false);  
+
   // Configure axes if requested 
   if (confaxes) ChangeAxesConfiguration(invx, invy, exchxy, false);
@@ -691,4 +686,5 @@
       SetLut(t_al, min_al, max_al, Lut()->Type(), ns_al, false);
   }
+
   return(ndec+ndec2);
 }
@@ -728,4 +724,5 @@
      (cmapid == CMAP_GREY128) || (cmapid == CMAP_GREYINV128))  mdrw->GetGraphicAtt().SetColAtt(PI_Red);
 else mdrw->GetGraphicAtt().SetColAtt(PI_Turquoise);
+if (lut) lut->SetNCol(cmp->NCol());
 PIPixmap::SetColMap(cmp, refr);
 if (refr) { xcurs =  ycurs = -1; }
@@ -742,5 +739,7 @@
      (cmapid == CMAP_GREY128) || (cmapid == CMAP_GREYINV128))  mdrw->GetGraphicAtt().SetColAtt(PI_Red);
 else mdrw->GetGraphicAtt().SetColAtt(PI_Turquoise);
-PIPixmap::SetColMapId(cmapid, revidx, refr);
+PIPixmap::SetColMapId(cmapid, revidx, false);
+if (lut) lut->SetNCol(GetColMap()->NCol());
+if (refr) Refresh();
 if (zow)  zow->SetColMapId(cmapid, revidx, refr);
 if (gvw)  gvw->SetColMapId(cmapid, revidx, refr);
@@ -1111,14 +1110,14 @@
 ywsz = YSize();
 
-pixm = img->ComputePixmap(lut, offx, offy, zoom, xwsz, ywsz, pixm, &xspxm, &yspxm);
+img->ComputePixmap(lut, offx, offy, zoom, xwsz, ywsz, pixm);
 int xw1, yw1, xw2, yw2;
-xw1 = (xwsz-xspxm)/2;
+xw1 = (xwsz-pixm.XSize())/2;
 if (xw1 < 0) xw1 = 0;
-yw1 = (ywsz-yspxm)/2;
+yw1 = (ywsz-pixm.YSize())/2;
 if (yw1 < 0) yw1 = 0;
-xw2 = xspxm+xw1;
-yw2 = yspxm+yw1;
+xw2 = pixm.XSize()+xw1;
+yw2 = pixm.YSize()+yw1;
 SetDefaultDrawRectangle(xw1, yw1, xw2, yw2, false);
-// printf("--DBG-- ComputePixmap() %d %d $ %d %d :: %d %d , %d %d \n", xwsz, ywsz, xspxm, yspxm, xw1, yw1, xw2, yw2);
+// printf("--DBG-- ComputePixmap() %d %d $ %d %d :: %d %d , %d %d \n", xwsz, ywsz, pixm.XSize(), pixm.YSize(), xw1, yw1, xw2, yw2);
 int x1,y1, x2,y2;
 ofx = xw1;  ofy = yw1;
@@ -1131,5 +1130,5 @@
 // printf("--DBG2-- ComputePixmap() %g %g  %g %g  \n", fx1, fx2, fy1, fy2);
 xcurs = ycurs = -1;
-SetPixmap(pixm, xspxm, yspxm, true, xw1, yw1); 
+SetPixmap(&pixm, true, xw1, yw1); 
 // Refresh();
 return; 
@@ -1174,7 +1173,7 @@
 if (lofy < 0)  lofy = 0;
 
-zpixm = img->ComputePixmap(lut, lofx, lofy, zm, xwsz, ywsz, zpixm, &xszpxm, &yszpxm);
+img->ComputePixmap(lut, lofx, lofy, zm, xwsz, ywsz, zpixm);
 zow->SetColMap(cmap, false);
-zow->SetPixmap(zpixm, xszpxm, yszpxm); 
+zow->SetPixmap(&zpixm); 
 zow->SetUserData((void *)this, 0);
 // zow->Refresh();
@@ -1203,6 +1202,6 @@
 zmgv = zmx;
 if (zmx > 1)  zmx = -zmx;
-gpixm = img->ComputePixmap(lut, 0, 0, zmx, xwsz, ywsz, gpixm, &xsgpxm, &ysgpxm);
-// printf("DEBUG-ComputeGloVPixmap()  %d-%d , (%d,%d) , %d-%d \n", xwsz, ywsz, zmx, zmy, xsgpxm, ysgpxm);
+img->ComputePixmap(lut, 0, 0, zmx, xwsz, ywsz, gpixm);
+// printf("DEBUG-ComputeGloVPixmap()  %d-%d , (%d,%d) , %d-%d \n", xwsz, ywsz, zmx, zmy, gpixm.XSize(), gpixm.YSize());
 return;
 }
@@ -1215,10 +1214,10 @@
 
 int xw1, yw1, xw2, yw2;
-xw1 = (gvw->XSize()-xsgpxm)/2;
+xw1 = (gvw->XSize()-gpixm.XSize())/2;
 if (xw1 < 0) xw1 = 0;
-yw1 = (gvw->YSize()-ysgpxm)/2;
+yw1 = (gvw->YSize()-gpixm.YSize())/2;
 if (yw1 < 0) yw1 = 0;
-xw2 = xsgpxm+xw1;
-yw2 = ysgpxm+yw1;
+xw2 = gpixm.XSize()+xw1;
+yw2 = gpixm.YSize()+yw1;
 
 if (zoom > 0) zm = zmgv*zoom;
@@ -1242,5 +1241,5 @@
 gvw->AddDrawer(gvdrw, xw1, yw1, xw2, yw2, false); 
 gvw->SetColMap(cmap, false);
-gvw->SetPixmap(gpixm, xsgpxm, ysgpxm, true, xw1, yw1); 
+gvw->SetPixmap(&gpixm, true, xw1, yw1); 
 gvw->SetUserData((void *)this, 0);
 gvw->SetMsg(Msg()+626);
Index: /trunk/SophyaPI/PI/piimage.h
===================================================================
--- /trunk/SophyaPI/PI/piimage.h	(revision 3518)
+++ /trunk/SophyaPI/PI/piimage.h	(revision 3519)
@@ -154,6 +154,5 @@
   bool winovis;   // $CHECK$ Reza A enlever si possible 17/6/96
 // Tableau des pixels principal  
-  unsigned char * pixm;
-  int xspxm, yspxm;
+  PIPixColIdx pixm;
   LUT * lut;
   AutoLutType t_al;   // Si AutoLut et le type lors du dernier appel a SetLut()
@@ -164,11 +163,9 @@
   int zoom;
   PIPixmap * zow;
-  unsigned char * zpixm;
-  int xszpxm, yszpxm;
-// Fenetre pour l'image entiere  
+  PIPixColIdx zpixm;
+// Fenetre pour vue globale de l'image   
   int zmgv;
   PIPixmap * gvw;
-  unsigned char * gpixm;
-  int xsgpxm, ysgpxm;
+  PIPixColIdx gpixm;
   PIElDrawer* gvdrw;
 // Fenetre d'affichage du ColMap
